diff -Nurp '--exclude=.bzr*' tin-2.6.4/src/cook.c tin-2.6.5/src/cook.c
--- tin-2.6.4/src/cook.c	2024-12-04 18:12:24.000000000 +0100
+++ tin-2.6.5/src/cook.c	2025-12-13 09:50:24.183556469 +0100
@@ -1234,26 +1874,154 @@ process_text_body_part(
 		buf = line;
 
 		/*
-		 * Skip over the first space in case of Format=Flowed (space-stuffing)
+		 * Skip over the first space in case of Format=Flowed
+		 * (RFC 3676 4.4 Space-Stuffing)
+		 * #if 1
+		 * _except_ for lines starting with " ", " >" or " From "
+		 * (this is NOT what the RFC says).
+		 * #endif
+		 * quote depth adjustment, 1st level only.
 		 */
-		if (part->format == FORMAT_FLOWED) {
-			if (line[0] == ' ')
+		if (part->format == FORMAT_FLOWED && line[0] == ' ') {
+			if (line[1] == '>' && (flags & C_QUOTE1))
+				flags &= ~C_QUOTE1;
+
+#if 0
+			if (line[1] != '>' && line[1] != ' ' && strncmp(line + 1, "From ", 5))
+#endif /* 0 */
 				++buf;
 		}
 
+		/*
+		 * skip over what "looks" like an unexpected yenc line.
+		 * in contrast to partial uue we don't store the data
+		 */
+		if (raw_len) {
+#ifdef HAVE_COLOR
+			flags &= ~(C_CTRLL | C_QUOTE1 | C_QUOTE2 | C_QUOTE3 | C_EXTQUOTE);
+#else
+			flags &= ~(C_CTRLL | C_QUOTE1 | C_QUOTE2 | C_QUOTE3);
+#endif /* HAVE_COLOR */
+			if (flags == C_BODY && (*line != '=' || *(line + 1) != 'y') && (strcmp(raw_line, line) || lines_hidden > 100)) {
+				if (!(section & (SHAR_SECTION | PGP_ANY_SECTION))) {
+					++lines_hidden;
+					continue;
+				}
+			}
+		}
+
+		/* TODO: shall we also look for PGP_PRIVATE_KEY_TAG? */
+		if ((hide_inline_data & PGP_ALL) && section == TEXT_SECTION && !strcmp(line, PGP_PUBLIC_KEY_TAG)) {
+			section |= PGP_KEY_SECTION;
+			++non_attach_lines;
+			continue;
+		}
+		if ((hide_inline_data & PGP_ALL) && section == PGP_KEY_SECTION) {
+			if (!strcmp(line, PGP_PUBLIC_KEY_END_TAG)) { /* see above, PGP_PRIVATE_KEY_END_TAG */
+				++non_attach_lines;
+				section &= ~PGP_KEY_SECTION;
+				/* -> lang.c && _("OpenPGP public key block") */
+				put_cooked(LEN, wrap_lines, C_BODY, P_(txt_cook_lines_hidden_sp[0], txt_cook_lines_hidden_sp[1], non_attach_lines), "OpenPGP pubic key block", non_attach_lines);
+				non_attach_lines = 0;
+				continue;
+			} else
+				++non_attach_lines;
+			continue;
+		}
+
+		if ((hide_inline_data & PGP_ALL) && section == TEXT_SECTION && !strcmp(line, PGP_SIG_TAG)) {
+			section |= PGP_SIG_SECTION;
+			++non_attach_lines;
+			continue;
+		}
+		if ((hide_inline_data & PGP_ALL) && section == PGP_SIG_SECTION) {
+			if (!strcmp(line, PGP_SIG_END_TAG)) {
+				++non_attach_lines;
+				section &= ~PGP_SIG_SECTION;
+				/* -> lang.c && _("OpenPGP signature block") */
+				put_cooked(LEN, wrap_lines, C_BODY, P_(txt_cook_lines_hidden_sp[0], txt_cook_lines_hidden_sp[1], non_attach_lines), "OpenPGP signature block", non_attach_lines);
+				non_attach_lines = 0;
+				continue;
+			} else
+				++non_attach_lines;
+			continue;
+		}
+
+		if ((hide_inline_data & SHAR_ALL) && section == SHAR_SECTION) {
+			++non_attach_lines;
+			if (MATCH_REGEX(shar_end_regex, line, len)) {
+				/* -> lang.c && _("shell archive (shar)") */
+				put_cooked(LEN, wrap_lines, C_BODY, P_(txt_cook_lines_hidden_sp[0], txt_cook_lines_hidden_sp[1], non_attach_lines), "shell archive (shar)", non_attach_lines);
+				non_attach_lines = 0;
+				section &= ~SHAR_SECTION;
+			}
+			continue;
+		} else {
+			if ((hide_inline_data & SHAR_ALL) && section == TEXT_SECTION && MATCH_REGEX(shar_regex, line, len)) {
+				++non_attach_lines;
+				section |= SHAR_SECTION;
+				continue;
+			}
+		}
+
+		/*
+		 * TODO: add a key on/off toggle (e.g. '{' or '}')
+		 *
+		 * be aware that trim_article_body may have kicked in before!
+		 */
+		if (MATCH_REGEX(hideline_regex, buf, len))
+			continue;
+
 		put_cooked(max_line_len, wrap_lines && (!IS_LOCAL_CHARSET("Big5")), flags, "%s", buf);
 	} /* while */
 
 	/*
-	 * Were we reading uue and ran off the end ?
+	 * Were we reading uue/yenc and ran off the end ?
 	 */
-	if (in_uue && hide_uue)
-		put_attach(wrap_lines, curruue, (curruue->depth - 1) * 4, UUE_INCOMPLETE, get_filename(curruue->params), content_encodings[curruue->encoding]);
+	if ((section & UUE_SECTION) && (hide_inline_data & UUE_ALL))
+		put_attach(wrap_lines, curruue, (curruue->depth - 1) * 4, SECTION_UUE_INCOMPLETE, get_filename(curruue->params), content_encodings[curruue->encoding]);
+	else
+		if ((section & YENC_SECTION) && hide_inline_data) {
+			curruue->yenc_part = y_part ? y_part : 1; /* fixup display when no =part was found */
+			curruue->yenc_total = y_total ? y_total : 1; /* fixup display when no =total was found */
+			curruue->yenc_part_size = y_pend && (y_pend - y_pbegin) ? y_pend - y_pbegin : y_bsize == y_esize ? y_bsize : 0;
+			curruue->yenc_total_size = y_bsize;
+			curruue->yenc_crc = y_ccrc;
+			put_attach(wrap_lines, curruue, (curruue->depth - 1) * 4, SECTION_YENC_INCOMPLETE, get_filename(curruue->params), content_encodings[curruue->encoding]);
+			FreeAndNull(y_name);
+		}
+
+	if (!(section & YENC_SECTION) && lines_hidden && (hide_inline_data & UUE_ALL))
+		put_cooked(LEN, wrap_lines, C_BODY, P_(txt_cook_lines_hidden_sp[0], txt_cook_lines_hidden_sp[1], lines_hidden), _(txt_yenc_partial), lines_hidden);
+
+	if (section != TEXT_SECTION && non_attach_lines) {
+		if ((section & SHAR_SECTION) && (hide_inline_data & SHAR_ALL))
+			put_cooked(LEN, wrap_lines, C_BODY, P_(txt_cook_lines_hidden_sp[0], txt_cook_lines_hidden_sp[1], non_attach_lines), "shar archive", non_attach_lines);
+
+		if ((section & PGP_KEY_SECTION) && (hide_inline_data & PGP_ALL))
+			put_cooked(LEN, wrap_lines, C_BODY, P_(txt_cook_lines_hidden_sp[0], txt_cook_lines_hidden_sp[1], non_attach_lines), "OpenPGP public key block", non_attach_lines);
+
+		if ((section & PGP_SIG_SECTION) && (hide_inline_data & PGP_ALL))
+			put_cooked(LEN, wrap_lines, C_BODY, P_(txt_cook_lines_hidden_sp[0], txt_cook_lines_hidden_sp[1], non_attach_lines), "OpenPGP signature block", non_attach_lines);
+
+#ifdef INLINE_DEBUG_MIME
+		put_cooked(LEN, wrap_lines, C_BODY, "[-- Error: unexpected %s --]", "end. No mark found.");
+#endif /* INLINE_DEBUG_MIME */
+	}
 
 	free(line);
+	FreeIfNeeded(raw_line);
 }
 
 
+#undef GET_YENC_SECTION_TYPE
+#undef PUT_YENC_HEADER
+#undef DEBUG_PUT_YENC_INVALID_ITEM
+#undef DEBUG_PUT_YENC_MISSING_OR_EMPTY_PARAM
+#undef DEBUG_PUT_YENC_UNEXPECTED_ITEM
+#undef DEBUG_PUT_YENC_CRC32_MISMATCH
+
+
 /*
  * Return TRUE if this header should be printed as per
  * news_headers_to_[not_]display
@@ -1310,31 +2078,6 @@ dump_cooked(
 #endif /* DEBUG_ART */
 
 
-/*
- * 'cooks' an article, ie, prepare what will actually appear on the screen
- * It is not easy to do this in the same pass as the initial read since
- * boundary conditions for multipart articles make it harder to do on the
- * fly decoding.
- * We could have cooked the headers whilst they were being read but we're
- * trying to keep this simple.
- *
- * Expects:
- *		Fresh article context to write into
- *		parse_uue is set only when the art is opened to create t_parts for
- *		uue sections found, when resizing this is not needed
- *		hide_uue determines the folding of uue sections
- * Handles:
- *		multipart articles
- *		stripping of non text sections if skip_alternative
- *		Q and B decoding of text sections
- *		handling of uuencoded sections
- *		stripping of sigs if !show_signatures
- * Returns:
- *		TRUE on success
- *
- * TODO:
- *      give an error-message on at least disk-full
- */
 /* set INLINE_DEBUG_MIME to 1 to inline report some errors/warnings,
  * use PAGE_ARTICLE_INFO ('\'') for a more detailed info.
  * strings -> lang.c?
@@ -1343,14 +2086,14 @@ t_bool
 cook_article(
 	t_bool wrap_lines,
 	t_openartinfo *artinfo,
-	int hide_uue,
+	int hide_inline_data,
 	t_bool show_all_headers)
 {
 	const char *charset;
 	const char *name;
 	char *line;
 	struct t_header *hdr = &artinfo->hdr;
-	static const char *struct_header[] = {
+	static const char *struct_header[] = { /* as in rfc2047.c:rfc1522_do_encode() */
 		"Approved: ", "From: ", "Originator: ", "Reply-To: ",
 		"Sender: ", "To: ", "Cc: ", "Bcc: ", "X-Cancelled-By: ",
 		"X-Comment-To: ", "X-Submissions-To: ", "X-Originator: ",
@@ -1400,6 +2143,10 @@ cook_article(
 			t_bool found = FALSE;
 
 			/* structured headers */
+			/*
+			 * TODO: should we look for URLs in headers too?
+			 * (make this configurable?)
+			 */
 			do {
 				if (!strncasecmp(line, *strptr, strlen(*strptr))) {
 					foo = my_strdup(*strptr);
@@ -1408,6 +2155,7 @@ cook_article(
 						unfold_header(line);
 						if ((ptr = parse_mb_list_header(line, foo))) {
 #if 0
+							char *idnp;
 							/*
 							 * TODO:
 							 * idna_decode() currently expects just a FQDN
@@ -1417,11 +2165,56 @@ cook_article(
 							 * (?i)((?:\S+\.)?xn--[a-z0-9\.\-]{3,}\S+)\b
 							 * and just decode $1
 							 * maybe also in process_text_body_part()
+							 * (after looking for url_regex & co)
+							 *
+							 * the following is quick'n'dirty and
+							 * can't cope with multiple addresses.
+							 * it needs a rewrite/cleanup to
+							 * some idna_decode_line() which just
+							 * decodes all the idna-parts in it and
+							 * keeps he rest of the line as is
 							 */
-							bar = idna_decode(ptr);
-#else
-							bar = my_strdup(ptr);
+
+							/* something which looks like IDNA? */
+							if ((idnp = strcasestr(ptr, ACE_PREFIX)) != NULL) {
+								char *t = NULL;
+								char *ep = idnp;
+								char k;
+
+								/* look for fqdn start */
+								while (idnp > ptr && (*(idnp - 1) == '+' || *(idnp - 1) == '-' || *(idnp - 1) == '.' || isalnum((int) *(idnp - 1))))
+									--idnp;
+
+								/* keep beginng of the line before idna part */
+								bar = my_calloc(strlen(ptr) - strlen(idnp) + 1, 1);
+								snprintf(bar, strlen(ptr) - strlen(idnp) + 1, "%s", ptr);
+
+								/* look for fqdn end */
+								while (*ep != '\0' && (*ep == '+' || *ep == '-' || *ep == '.' || isalnum((int) *ep)))
+									++ep;
+								/* remember "end" = first non fqdn char */
+								k = *ep;
+								/* terminate fqdn */
+								*ep = '\0';
+								if (idnp > ptr && *(idnp - 1) == '@' && strlen(idnp) >= 10 && strchr(idnp, '.')) { /* follows an '@', has idna min. len and at least one '.' */
+									/* decode */
+									t = idna_decode(idnp);
+									/* append idn data */
+									bar = append_to_string(bar, t);
+									free(t);
+									/* restore end char */
+									*ep = k;
+									if (ep <= (ptr + strlen(ptr))) /* append tail */
+										bar = append_to_string(bar, ep);
+								} else { /* use original data */
+									*ep = k;
+									free(bar);
+									bar = my_strdup(ptr);
+								}
+							} else
 #endif /* 0 */
+								bar = my_strdup(ptr);
+
 							l = my_calloc(1, strlen(bar) + strlen(*strptr) + 1);
 							strncpy(l, line, strlen(*strptr));
 							strcat(l, bar);
@@ -1433,17 +2226,16 @@ cook_article(
 				}
 			} while (!found && *(++strptr) != NULL);
 
-			/* unstructured but must not be decoded */
-			if (l == NULL && (!strncasecmp(line, "References: ", 12) || !strncasecmp(line, "Message-ID: ", 12) || !strncasecmp(line, "Date: ", 6) || !strncasecmp(line, "Newsgroups: ", 12) || !strncasecmp(line, "Distribution: ", 14) || !strncasecmp(line, "Followup-To: ", 13) || !strncasecmp(line, "X-Face: ", 8) || !strncasecmp(line, "Cancel-Lock: ", 13) || !strncasecmp(line, "Cancel-Key: ", 12) || !strncasecmp(line, "Supersedes: ", 12)))
+			/* unstructured but must not be decoded (see also rfc2047.c:do_rfc15211522_encode()) */
+			if (l == NULL && (!strncasecmp(line, "Date: ", 6) || !strncasecmp(line, "Path: ", 6) || !strncasecmp(line, "Xref: ", 6) || !strncasecmp(line, "X-Face: ", 8) || !strncasecmp(line, "Newsgroups: ", 12) || !strncasecmp(line, "References: ", 12) || !strncasecmp(line, "Message-ID: ", 12) || !strncasecmp(line, "Supersedes: ", 12) || !strncasecmp(line, "Cancel-Key: ", 12) || !strncasecmp(line, "Cancel-Lock: ", 13) || !strncasecmp(line, "Followup-To: ", 13) || !strncasecmp(line, "Distribution: ", 14)))
 				l = my_strdup(line);
 
 			if (l == NULL)
 				l = my_strdup(rfc1522_decode(line));
 
-#if defined(MULTIBYTE_ABLE) && !defined(NO_LOCALE)
 			if (IS_LOCAL_CHARSET("UTF-8"))
 				utf8_valid(l);
-#endif /* MULTIBYTE_ABLE && !NO_LOCALE */
+
 			header_put = TRUE;
 			expand_ctrl_chars(&l, &i, tabwidth);
 			put_cooked(i, wrap_lines, C_HEADER, "%s", l);
@@ -1483,7 +2275,7 @@ cook_article(
 			else
 				charset = NULL;
 
-			put_attach(wrap_lines, ptr, (ptr->depth - 1) * 4, 0, name, charset);
+			put_attach(wrap_lines, ptr, (ptr->depth - 1) * 4, SECTION_DEFAULT, name, charset);
 
 			/* Try to view anything of type text, may need to review this */
 			if (IS_PLAINTEXT(ptr)) {
@@ -1493,7 +2285,7 @@ cook_article(
 						put_cooked(1, wrap_lines, C_ATTACH, "\n");
 				} else {
 					charset = validate_charset(charset);
-					process_text_body_part(wrap_lines, artinfo->raw, charset ? charset : "US-ASCII", ptr, hide_uue);
+					process_text_body_part(wrap_lines, artinfo->raw, charset ? charset : "US-ASCII", ptr, hide_inline_data);
 				}
 			}
 		}
@@ -1513,7 +2305,7 @@ cook_article(
 
 #ifdef CHARSET_CONVERSION
 #	ifdef USE_ICU_UCSDET
-		if (hdr->ext->type == TYPE_APPLICATION && hdr->ext->encoding == ENCODING_BINARY && artinfo->hdr.ext->mime_hints.flags & MIME_TRANSFER_ENCODING_UNKNOWN) {
+		if (hdr->ext->type == TYPE_APPLICATION && hdr->ext->encoding == ENCODING_BINARY && (artinfo->hdr.ext->mime_hints.flags & MIME_TRANSFER_ENCODING_UNKNOWN)) {
 			put_cooked(LEN, wrap_lines, C_ATTACH, "[-- \"Content-Type: application/octet-stream\" forced --]\n");
 			put_cooked(LEN, wrap_lines, C_ATTACH, "[-- \"Content-Type-Encodig: %s\" forced --]\n", content_encodings[hdr->ext->encoding]);
 		}
@@ -1539,13 +2331,13 @@ cook_article(
 			if (hdr->ext->mime_hints.flags & MIME_CHARSET_UNSUPPORTED)
 				put_cooked(LEN, wrap_lines, C_ATTACH, _(txt_mime_unsup_charset), 0, "", hdr->ext->mime_hints.charset);
 			else
-				process_text_body_part(wrap_lines, artinfo->raw, charset ? charset : "US-ASCII", hdr->ext, hide_uue);
+				process_text_body_part(wrap_lines, artinfo->raw, charset ? charset : "US-ASCII", hdr->ext, hide_inline_data);
 		} else {
 			/*
 			 * Non-textual main body
 			 */
 			name = get_filename(hdr->ext->params);
-			put_attach(wrap_lines, hdr->ext, 0, 0, name, BlankIfNull(charset));
+			put_attach(wrap_lines, hdr->ext, 0, SECTION_DEFAULT, name, BlankIfNull(charset));
 		}
 	}
 
@@ -1575,9 +2367,10 @@ ltobi(
 	char r;
 	unsigned d = 0, e = 0;
 
-#if !defined(NO_LOCALE) && defined(HAVE_LANGINFO_CODESET)
-	if (!(r = nl_langinfo(RADIXCHAR)[0]))
-#endif /* !NO_LOCALE && HAVE_LANGINFO_CODESET */
+#if !defined(NO_LOCALE)
+	r = tin_nl_langinfo(RADIXCHAR)[0];
+	if (r == '\0')
+#endif /* !NO_LOCALE */
 		r = '.';
 
 	while (i >= BI_BASE) {
diff -Nurp '--exclude=.bzr*' tin-2.6.4/src/crc32.c tin-2.6.5/src/crc32.c
--- tin-2.6.4/src/crc32.c	1970-01-01 01:00:00.000000000 +0100
+++ tin-2.6.5/src/crc32.c	2025-11-13 02:21:32.344169697 +0100
@@ -0,0 +1,149 @@
+/*
+ *  COPYRIGHT (C) 1986 Gary S. Brown.  You may use this program, or
+ *  code or tables extracted from it, as desired without restriction.
+ *
+ *  First, the polynomial itself and its table of feedback terms.  The
+ *  polynomial is
+ *  X^32+X^26+X^23+X^22+X^16+X^12+X^11+X^10+X^8+X^7+X^5+X^4+X^2+X^1+X^0
+ *
+ *  Note that we take it "backwards" and put the highest-order term in
+ *  the lowest-order bit.  The X^32 term is "implied"; the LSB is the
+ *  X^31 term, etc.  The X^0 term (usually shown as "+1") results in
+ *  the MSB being 1.
+ *
+ *  Note that the usual hardware shift register implementation, which
+ *  is what we're using (we're merely optimizing it by doing eight-bit
+ *  chunks at a time) shifts bits into the lowest-order term.  In our
+ *  implementation, that means shifting towards the right.  Why do we
+ *  do it this way?  Because the calculated CRC must be transmitted in
+ *  order from highest-order term to lowest-order term.  UARTs transmit
+ *  characters in order from LSB to MSB.  By storing the CRC this way,
+ *  we hand it to the UART in the order low-byte to high-byte; the UART
+ *  sends each low-bit to high-bit; and the result is transmission bit
+ *  by bit from highest- to lowest-order term without requiring any bit
+ *  shuffling on our part.  Reception works similarly.
+ *
+ *  The feedback terms table consists of 256, 32-bit entries.  Notes
+ *
+ *      The table can be generated at runtime if desired; code to do so
+ *      is shown later.  It might not be obvious, but the feedback
+ *      terms simply represent the results of eight shift/xor opera-
+ *      tions for all combinations of data and CRC register values.
+ *
+ *      The values must be right-shifted by eight bits by the "updcrc"
+ *      logic; the shift must be unsigned (bring in zeroes).  On some
+ *      hardware you could probably optimize the shift in assembler by
+ *      using byte-swap instructions.
+ *      polynomial $edb88320
+ *
+ */
+
+#if 0
+#include <stdio.h>
+#include "crc32.h"
+#else
+#	ifndef TIN_H
+#		include "tin.h"
+#	endif /* !TIN_H */
+#	ifdef USE_ZLIB
+#		include <zlib.h>
+#	else
+		static inline uint32_t crc32_add_char(uint32_t crc, unsigned char c);
+		static uint32_t ul_crc32(uint32_t seed, const unsigned char *buf, size_t len);
+#	endif /* !USE_ZLIB */
+#endif /* 0 */
+
+
+uint32_t
+tin_crc32(
+	uint32_t crc,
+	const unsigned char *buf,
+	size_t len)
+{
+	if (!buf || !len)
+		return 0;
+#ifdef USE_ZLIB
+	return crc32((unsigned long) crc, buf, len);
+#else
+	return ~ul_crc32(~crc, buf, len);
+#endif /* USE_ZLIB */
+}
+
+
+#ifndef USE_ZLIB
+static const uint32_t crc32_tab[] = {
+	0x00000000L, 0x77073096L, 0xee0e612cL, 0x990951baL, 0x076dc419L,
+	0x706af48fL, 0xe963a535L, 0x9e6495a3L, 0x0edb8832L, 0x79dcb8a4L,
+	0xe0d5e91eL, 0x97d2d988L, 0x09b64c2bL, 0x7eb17cbdL, 0xe7b82d07L,
+	0x90bf1d91L, 0x1db71064L, 0x6ab020f2L, 0xf3b97148L, 0x84be41deL,
+	0x1adad47dL, 0x6ddde4ebL, 0xf4d4b551L, 0x83d385c7L, 0x136c9856L,
+	0x646ba8c0L, 0xfd62f97aL, 0x8a65c9ecL, 0x14015c4fL, 0x63066cd9L,
+	0xfa0f3d63L, 0x8d080df5L, 0x3b6e20c8L, 0x4c69105eL, 0xd56041e4L,
+	0xa2677172L, 0x3c03e4d1L, 0x4b04d447L, 0xd20d85fdL, 0xa50ab56bL,
+	0x35b5a8faL, 0x42b2986cL, 0xdbbbc9d6L, 0xacbcf940L, 0x32d86ce3L,
+	0x45df5c75L, 0xdcd60dcfL, 0xabd13d59L, 0x26d930acL, 0x51de003aL,
+	0xc8d75180L, 0xbfd06116L, 0x21b4f4b5L, 0x56b3c423L, 0xcfba9599L,
+	0xb8bda50fL, 0x2802b89eL, 0x5f058808L, 0xc60cd9b2L, 0xb10be924L,
+	0x2f6f7c87L, 0x58684c11L, 0xc1611dabL, 0xb6662d3dL, 0x76dc4190L,
+	0x01db7106L, 0x98d220bcL, 0xefd5102aL, 0x71b18589L, 0x06b6b51fL,
+	0x9fbfe4a5L, 0xe8b8d433L, 0x7807c9a2L, 0x0f00f934L, 0x9609a88eL,
+	0xe10e9818L, 0x7f6a0dbbL, 0x086d3d2dL, 0x91646c97L, 0xe6635c01L,
+	0x6b6b51f4L, 0x1c6c6162L, 0x856530d8L, 0xf262004eL, 0x6c0695edL,
+	0x1b01a57bL, 0x8208f4c1L, 0xf50fc457L, 0x65b0d9c6L, 0x12b7e950L,
+	0x8bbeb8eaL, 0xfcb9887cL, 0x62dd1ddfL, 0x15da2d49L, 0x8cd37cf3L,
+	0xfbd44c65L, 0x4db26158L, 0x3ab551ceL, 0xa3bc0074L, 0xd4bb30e2L,
+	0x4adfa541L, 0x3dd895d7L, 0xa4d1c46dL, 0xd3d6f4fbL, 0x4369e96aL,
+	0x346ed9fcL, 0xad678846L, 0xda60b8d0L, 0x44042d73L, 0x33031de5L,
+	0xaa0a4c5fL, 0xdd0d7cc9L, 0x5005713cL, 0x270241aaL, 0xbe0b1010L,
+	0xc90c2086L, 0x5768b525L, 0x206f85b3L, 0xb966d409L, 0xce61e49fL,
+	0x5edef90eL, 0x29d9c998L, 0xb0d09822L, 0xc7d7a8b4L, 0x59b33d17L,
+	0x2eb40d81L, 0xb7bd5c3bL, 0xc0ba6cadL, 0xedb88320L, 0x9abfb3b6L,
+	0x03b6e20cL, 0x74b1d29aL, 0xead54739L, 0x9dd277afL, 0x04db2615L,
+	0x73dc1683L, 0xe3630b12L, 0x94643b84L, 0x0d6d6a3eL, 0x7a6a5aa8L,
+	0xe40ecf0bL, 0x9309ff9dL, 0x0a00ae27L, 0x7d079eb1L, 0xf00f9344L,
+	0x8708a3d2L, 0x1e01f268L, 0x6906c2feL, 0xf762575dL, 0x806567cbL,
+	0x196c3671L, 0x6e6b06e7L, 0xfed41b76L, 0x89d32be0L, 0x10da7a5aL,
+	0x67dd4accL, 0xf9b9df6fL, 0x8ebeeff9L, 0x17b7be43L, 0x60b08ed5L,
+	0xd6d6a3e8L, 0xa1d1937eL, 0x38d8c2c4L, 0x4fdff252L, 0xd1bb67f1L,
+	0xa6bc5767L, 0x3fb506ddL, 0x48b2364bL, 0xd80d2bdaL, 0xaf0a1b4cL,
+	0x36034af6L, 0x41047a60L, 0xdf60efc3L, 0xa867df55L, 0x316e8eefL,
+	0x4669be79L, 0xcb61b38cL, 0xbc66831aL, 0x256fd2a0L, 0x5268e236L,
+	0xcc0c7795L, 0xbb0b4703L, 0x220216b9L, 0x5505262fL, 0xc5ba3bbeL,
+	0xb2bd0b28L, 0x2bb45a92L, 0x5cb36a04L, 0xc2d7ffa7L, 0xb5d0cf31L,
+	0x2cd99e8bL, 0x5bdeae1dL, 0x9b64c2b0L, 0xec63f226L, 0x756aa39cL,
+	0x026d930aL, 0x9c0906a9L, 0xeb0e363fL, 0x72076785L, 0x05005713L,
+	0x95bf4a82L, 0xe2b87a14L, 0x7bb12baeL, 0x0cb61b38L, 0x92d28e9bL,
+	0xe5d5be0dL, 0x7cdcefb7L, 0x0bdbdf21L, 0x86d3d2d4L, 0xf1d4e242L,
+	0x68ddb3f8L, 0x1fda836eL, 0x81be16cdL, 0xf6b9265bL, 0x6fb077e1L,
+	0x18b74777L, 0x88085ae6L, 0xff0f6a70L, 0x66063bcaL, 0x11010b5cL,
+	0x8f659effL, 0xf862ae69L, 0x616bffd3L, 0x166ccf45L, 0xa00ae278L,
+	0xd70dd2eeL, 0x4e048354L, 0x3903b3c2L, 0xa7672661L, 0xd06016f7L,
+	0x4969474dL, 0x3e6e77dbL, 0xaed16a4aL, 0xd9d65adcL, 0x40df0b66L,
+	0x37d83bf0L, 0xa9bcae53L, 0xdebb9ec5L, 0x47b2cf7fL, 0x30b5ffe9L,
+	0xbdbdf21cL, 0xcabac28aL, 0x53b39330L, 0x24b4a3a6L, 0xbad03605L,
+	0xcdd70693L, 0x54de5729L, 0x23d967bfL, 0xb3667a2eL, 0xc4614ab8L,
+	0x5d681b02L, 0x2a6f2b94L, 0xb40bbe37L, 0xc30c8ea1L, 0x5a05df1bL,
+	0x2d02ef8dL
+};
+
+static inline uint32_t crc32_add_char(uint32_t crc, unsigned char c)
+{
+	return crc32_tab[(crc ^ c) & 0xff] ^ (crc >> 8);
+}
+
+/*
+ * This a generic crc32() function, it takes seed as an argument,
+ * and does __not__ xor at the end. Then individual users can do
+ * whatever they need.
+ */
+static uint32_t ul_crc32(uint32_t seed, const unsigned char *buf, size_t len)
+{
+	uint32_t crc = seed;
+	const unsigned char *p = buf;
+
+	while (len--)
+		crc = crc32_add_char(crc, *p++);
+
+	return crc;
+}
+#endif /* !USE_ZLIB */
diff -Nurp '--exclude=.bzr*' tin-2.6.4/src/curses.c tin-2.6.5/src/curses.c
--- tin-2.6.4/src/curses.c	2024-11-25 20:40:37.000000000 +0100
+++ tin-2.6.5/src/curses.c	2025-11-13 02:21:32.348169872 +0100
@@ -3,7 +3,7 @@
  *  Module    : curses.c
  *  Author    : D. Taylor & I. Lea
  *  Created   : 1986-01-01
- *  Updated   : 2024-07-28
+ *  Updated   : 2025-05-01
  *  Notes     : This is a screen management library borrowed with permission
  *              from the Elm mail system. This library was hacked to provide
  *              what tin needs.
@@ -82,8 +82,8 @@ t_bool have_linescroll = FALSE;
 #				define USE_SGTTY 1
 #				define TTY struct sgttyb
 /*
-	#			else
-	#				error "No termios.h, termio.h or sgtty.h found"
+#			else
+#				error "No termios.h, termio.h or sgtty.h found"
 */
 #			endif /* HAVE_SGTTY_H */
 #		endif /* HAVE_TERMIO_H */
@@ -126,8 +126,8 @@ static int _columns, _line, _lines, _col
 #				define SET_TTY(arg) stty(TTYIN, arg)
 #				define GET_TTY(arg) gtty(TTYIN, arg)
 /*
-	#			else
-	#				error "No termios.h, termio.h or sgtty.h found"
+#			else
+#				error "No termios.h, termio.h or sgtty.h found"
 */
 #			endif /* USE_SGTTY */
 #		endif /* USE_TERMIO */
@@ -544,7 +544,7 @@ StartInverse(
 /*	in_inverse = 1; */
 	if (_setinverse && tinrc.inverse_okay) {
 #	ifdef HAVE_COLOR
-		if (use_color) {
+		if (use_color && (tinrc.col_invers_bg != -1 || tinrc.col_invers_fg != -1)) {
 			bcol(tinrc.col_invers_bg);
 			fcol(tinrc.col_invers_fg);
 		} else {
@@ -568,7 +568,7 @@ EndInverse(
 /*	in_inverse = 0; */
 	if (_clearinverse && tinrc.inverse_okay) {
 #	ifdef HAVE_COLOR
-		if (use_color) {
+		if (use_color && (tinrc.col_invers_bg != -1 || tinrc.col_invers_fg != -1)) {
 			fcol(tinrc.col_normal);
 			bcol(tinrc.col_back);
 		} else {
diff -Nurp '--exclude=.bzr*' tin-2.6.4/src/debug.c tin-2.6.5/src/debug.c
--- tin-2.6.4/src/debug.c	2024-12-21 02:54:24.000000000 +0100
+++ tin-2.6.5/src/debug.c	2025-12-08 20:09:23.093717343 +0100
@@ -3,10 +3,10 @@
  *  Module    : debug.c
  *  Author    : I. Lea
  *  Created   : 1991-04-01
- *  Updated   : 2024-12-21
+ *  Updated   : 2025-12-08
  *  Notes     : debug routines
  *
- * Copyright (c) 1991-2025 Iain Lea <iain@bricbrac.de>
+ * Copyright (c) 1991-2026 Iain Lea <iain@bricbrac.de>
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -48,15 +48,15 @@
 #	endif /* !NEWSRC_H */
 #endif /* DEBUG */
 
-unsigned short debug;
+unsigned int debug = 0;
 
 #ifdef DEBUG
 /*
  * Local prototypes
  */
-static void debug_print_attributes(struct t_attribute *attr, FILE *fp);
+static void debug_print_attributes(const struct t_attribute *attr, FILE *fp);
 static void debug_print_filter(FILE *fp, int num, struct t_filter *the_filter);
-static void debug_print_newsrc(struct t_newsrc *lnewsrc, FILE *fp);
+static void debug_print_newsrc(const struct t_newsrc *lnewsrc, FILE *fp);
 
 
 /*
@@ -219,7 +219,7 @@ debug_print_active(
 
 static void
 debug_print_attributes(
-	struct t_attribute *attr,
+	const struct t_attribute *attr,
 	FILE *fp)
 {
 	if (attr == NULL)
@@ -329,13 +329,13 @@ debug_print_filters(
 	if (!*file)
 		joinpath(file, sizeof(file), tmpdir, "FILTER");
 
-	if ((fp = fopen(file, "w")) != NULL) {
+	if ((fp = fopen(file, "a")) != NULL) {
 		/*
 		 * print global filter
 		 */
 		num = glob_filter.num;
 		the_filter = glob_filter.filter;
-		fprintf(fp, "*** BEG GLOBAL FILTER=[%3d] ***\n", num);
+		fprintf(fp, "\n*** BEG GLOBAL FILTER=[%3d] ***\n", num);
 		for (i = 0; i < num; i++) {
 			debug_print_filter(fp, i, &the_filter[i]);
 			fprintf(fp, "\n");
@@ -445,7 +445,7 @@ debug_print_bitmap(
 
 static void
 debug_print_newsrc(
-	struct t_newsrc *lnewsrc,
+	const struct t_newsrc *lnewsrc,
 	FILE *fp)
 {
 	int j = 0;
@@ -468,27 +468,4 @@ debug_print_newsrc(
 	fprintf(fp, "]\n");
 	fflush(fp);
 }
-
-
-#	ifdef NNTP_ABLE
-const char *
-logtime(
-	void)
-{
-#		if defined(HAVE_CLOCK_GETTIME) || defined(HAVE_GETTIMEOFDAY)
-	static struct t_tintime log_time;
-	static char out[40];
-
-	if (tin_gettime(&log_time) == 0) {
-		if (my_strftime(out, 39, " [%H:%M:%S.", gmtime(&(log_time.tv_sec)))) {
-			snprintf(out + 11, sizeof(out) - 11, "%09ld", log_time.tv_nsec); /* strlen(" [hh:mm:ss.") */
-			out[17] = '\0'; /* strlen(" [hh:mm:ss.uuuuuu") */
-			strcat(out, "] ");
-			return out;
-		}
-	}
-#		endif /* HAVE_CLOCK_GETTIME || HAVE_GETTIMEOFDAY */
-	return " ";
-}
-#	endif /* NNTP_ABLE */
 #endif /* DEBUG */
diff -Nurp '--exclude=.bzr*' tin-2.6.4/src/envarg.c tin-2.6.5/src/envarg.c
--- tin-2.6.4/src/envarg.c	2024-11-25 20:40:37.000000000 +0100
+++ tin-2.6.5/src/envarg.c	2025-11-13 02:21:32.364170570 +0100
@@ -1,12 +1,12 @@
 /*
  *  Project   : tin - a Usenet reader
  *  Module    : envarg.c
- *  Author    : B. Davidson
+ *  Author    : B. Davidsen
  *  Created   : 1991-10-13
  *  Updated   : 2021-02-23
  *  Notes     : Adds default options from environment to command line
  *
- * Copyright (c) 1991-2025 Bill Davidson
+ * Copyright (c) 1991-2026 Bill Davidsen
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
